////////////////////////////////////////////////////////////
// ArrangeNote Script
//     wikichm.js - Generate HTML help with WIKI formatter
//     Copyright (C) 2004 Koichi Yamamoto
////////////////////////////////////////////////////////////

// XV:
//	Sep 30, 2004: ŏ̃o[WJ
//	Oct 12, 2004: O[v̔lɐݒ肵eLXg{ɕ\ĂoOC


// Get the file name of Microsoft(R) HTML Help Compiler ////////////////////////
var regkey = 'HKEY_CURRENT_USER\\Software\\YAMAKO\\genchm\\hhcPath';
var shell = new ActiveXObject( 'WScript.Shell' );
try {
	var compilerFileName = shell.RegRead( regkey );
} catch( e ) {
	ANScript.Message( "̃XNvgs邽߂ɂ\n" + 
			"Microsoft(R) HTML Help CompilerKvłB\n" + 
			"Compiler(hhc.exe)̊i[ꏊw肵ĂB" );
	while( true ) {
		compilerFileName = ANScript.ChooseFile( "hhc.exeIĂB", false );
		if ( !compilerFileName.length ) {
			ANScript.Quit();
		}
		if ( compilerFileName.substr( compilerFileName.lastIndexOf( '\\' ) + 1 ).toLowerCase() == 'hhc.exe' ) {
			break;
		}
		ANScript.Message( "hhc.exeIĂB" );
	}
	shell.RegWrite( regkey, compilerFileName, 'REG_SZ' );
}

// Get the note object /////////////////////////////////////////////////////////
var note = ANScript.GetNote();
if ( note.FileName.length > 0 ) {
	var notepath = note.FileName.substring( 0, note.FileName.lastIndexOf( '\\' ) + 1 );
} else {
	var notepath = '';
}

// Get the root object, and check it ///////////////////////////////////////////
var root = note.GetRootItem();
if ( !root.GetChildItemCount() ) {
	ANScript.Message( "̃m[gɂ͗vf1܂B" );
	ANScript.Quit();
}

// Create a work note object ///////////////////////////////////////////////////
var server = ANScript.CreateObject( 'arg.NoteService' );
var worknote = server.New();
var workimages = worknote.GetRootItem().NewItem( note.MEMOGROUP, note.CHILD );
var workindexes = worknote.GetRootItem().NewItem( note.MEMOGROUP, note.CHILD );
var worktopics = worknote.GetRootItem().NewItem( note.MEMOGROUP, note.CHILD );

// Get a file system object ////////////////////////////////////////////////////
var fso = ANScript.CreateObject( 'Scripting.FileSystemObject' );

// Prompt to choose the mode ///////////////////////////////////////////////////
var mode = ANScript.Choose( '[h(vr[|wv쐬)IĂB', 
		'"' + note.GetFocusItem().Title + '"vr[\nHTMLwvt@C(*.chm)쐬', 0 );
if ( mode == -1 ) {
	ANScript.Quit();
} else if ( mode == 0 ) {
	var css = copyCSS( fso.GetSpecialFolder( 2 ) + '\\wikichm_.css' );
	ANScript.Console( 'HTMLt@C쐬Ă܂...' );
	var file = genHTML( fso.GetSpecialFolder( 2 ) + '\\' + 'WikiChmPreview', note.GetFocusItem() );
	ANScript.Console( 'I\n' );
	ANScript.Console( 'HTMLvr[N܂B\n' );
	var ieprev = ANScript.ScriptFileName;
	ieprev = ieprev.substring( 0, ieprev.lastIndexOf( '\\' ) + 1 );
	ANScript.Execute( '"' + ieprev + 'IEPrev.exe" "' + file.FileName + '"' );
	file.Delete();
	css.Delete();
	deleteImages();
	ANScript.Quit();
}

// Prompt to enter the title ///////////////////////////////////////////////////
if ( note.FileName.length > 0 ) {
	var begin = note.FileName.lastIndexOf( '\\' );
	var end = note.FileName.lastIndexOf( '.' );
	if ( end < 0 ) {
		var title = note.FileName.substr( begin + 1 );
	} else {
		var title = note.FileName.substring( begin + 1, end );
	}
	var parentDir = note.FileName.substring( 0, begin + 1 );
} else {
	var title = "Vm[g";
	var parentDir = "";
}
title = ANScript.Input( "HTMLwṽ^Cg͂ĂB", title );
if ( !title.length ) {
	ANScript.Quit();
}

// Prompt to enter the .chm file name //////////////////////////////////////////
while( true ) {
	var chmFileName = ANScript.ChooseFile( 
			"HTMLwvt@C(*.chm)͂ĂB", false );
	if ( !chmFileName.length ) {
		ANScript.Quit();
	}
	var extIndex = chmFileName.lastIndexOf( '.' );
	if ( extIndex < 0 || chmFileName.substr( extIndex ) != '.chm' ) {
		chmFileName += ".chm";
	}
	if ( !/^\\\\/.test( chmFileName ) ) {
		break;
	}
	ANScript.Message( 'ۑ \\\\Rs[^\\L Ŏn܂閼O(UNC)͎wł܂B\n\n    ' + chmFileName );
}
extIndex = chmFileName.lastIndexOf( '.' );
var chmPathName = chmFileName.substring( 0, chmFileName.lastIndexOf( '\\' ) + 1 );
var chmName = chmFileName.substring( 
		chmFileName.lastIndexOf( '\\' ) + 1, extIndex );
var hhpFileName = chmPathName + chmName + ".hhp";
var hhcFileName = chmPathName + chmName + ".hhc";
var hhkFileName = chmPathName + chmName + ".hhk";
var batFileName = chmPathName + chmName + ".bat";
var logFileName = chmPathName + chmName + ".log";
var cssFileName = chmPathName + "wikichm_.css";
var r = ANScript.Confirm( "ȉ̃t@C쐬܂B\n\n" + 
		"Help\t" + chmFileName + "\n" + 
		"Project\t" + hhpFileName + "\n" + 
		"Contents\t" + hhcFileName + "\n" + 
		"Index\t" + hhkFileName + "\n" + 
		"HTML\t" + chmPathName + chmName + "-???.htm\n" + 
		"Images\t" + chmPathName + chmName + "-???.jpg|jpeg|png|gif\n" + 
		"Batch\t" + batFileName + "\n" + 
		"Log\t" + logFileName + "\n" + 
		"CSS\t" + cssFileName + "\n" + 
		"\n낵ł?", ANScript.YESNO );
if ( r != ANScript.YES ) {
	ANScript.Quit();
}

// Generate the HTML files /////////////////////////////////////////////////////
ANScript.Console( "HTMLt@C𐶐Ă܂..." );
genHTMLs( chmPathName + chmName, root );
ANScript.Console( "I\n" );

// Copy the css file ///////////////////////////////////////////////////////////
ANScript.Console( "CSSt@CRs[Ă܂..." );
var cssFile = copyCSS( cssFileName );
ANScript.Console( "I\n" );

// Generate the project file ///////////////////////////////////////////////////
ANScript.Console( "vWFNgt@C𐶐Ă܂..." );
var hhp = '';
var defaultTopic = chmPathName + chmName + '-' + 
		root.GetItem( note.CHILD ).Id + '.htm';

// [OPTIONS] section
hhp += '[OPTIONS]\n' + 
		'Compatibility=1.1 or later' + 
		'Compiled file=' + chmFileName + '\n' + 
		'Contents file=' + hhcFileName + '\n' + 
		'Default Window=windowType\n' + 
		'Default topic=' + defaultTopic + '\n' + 
		'Display compile progress=Yes\n' + 
		'Full-text search=Yes\n' + 
		'Index file=' + hhkFileName + '\n' + 
		'Language=0x411\n' + 
		'Title=' + title + '\n';

// [WINDOWS] section
hhp += '[WINDOWS]\n' + 
		'windowType="' + title + '","' + 
		hhcFileName + '","' + hhkFileName + '","' + 
		defaultTopic + '","' + defaultTopic + '",,,,,0x22520,,0x384e,,,,,,,,0\n';

// [FILES] section
hhp += '[FILES]\n' + 
		defaultTopic + '\n';

// [INFOTYPES] section
hhp += '[INFOTYPES]\n';

// write to file
var hhpFile = ANScript.FileObject( hhpFileName );
hhpFile.Write( hhp );

ANScript.Console( "I\n" );

// Generate Contents file //////////////////////////////////////////////////////
ANScript.Console( "Contentst@C𐶐Ă܂..." );
var hhc = '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">\n' + 
		'<html>\n' + 
		'<head><meta name="GENERATOR" content="HTML Help Generator for ArrangeNote"></head>\n' + 
		'<body>\n';
// Note: The following code changes the icon in the tree view.
//hhc += '<object type="text/site properties">\n' + 
//		'<param name="ImageType" value="Folder">\n' + 
//		'</object>\n';
genContentsBody( root );
hhc += '</body>\n' + 
		'</html>\n';
var hhcFile = ANScript.FileObject( hhcFileName );
hhcFile.Write( hhc );
ANScript.Console( "I\n" );

// Generate Index file /////////////////////////////////////////////////////////
ANScript.Console( "Indext@C𐶐Ă܂..." );
var hhk = '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">\n' + 
		'<html>\n' + 
		'<head><meta name="GENERATOR" content="HTML Help Generator for ArrangeNote"></head>\n' + 
		'<body>\n';
genIndexBody( root );
genIndexBodyWiki();
hhk += '</body>\n' + 
		'</html>\n';
var hhkFile = ANScript.FileObject( hhkFileName );
hhkFile.Write( hhk );
ANScript.Console( "I\n" );

// Generate Batch file and execute it //////////////////////////////////////////
ANScript.Console( "wvRpCsĂ܂..." );
var batFile = ANScript.FileObject( batFileName );
batFile.Write( '"' + compilerFileName + '" "' + hhpFileName + '" >> "' + logFileName + '"\n' +
		'@echo RpCI܂BMS-DOSvvgĂB\n' );
ANScript.Execute( batFileName );
ANScript.Console( "I\n" );

// Confirm the log file ////////////////////////////////////////////////////////
r = ANScript.Confirm( "Ot@C̓emF܂?", ANScript.YESNO );
if ( r == ANScript.YES ) {
	ANScript.Console( " Ot@COGfB^ŊJĂ܂B\n t@C: " + 
			logFileName + "\n OGfB^Ə𑱍s܂B\n" );
	ANScript.Execute( '"' + ANScript.EditorName + '" "' + logFileName + '"' );
}

// Delete temporary files //////////////////////////////////////////////////////
r = ANScript.Confirm( "ȉ̒ԃt@C폜܂B\n\n" + 
		"Project\t" + hhpFileName + "\n" + 
		"Contents\t" + hhcFileName + "\n" + 
		"Index\t" + hhkFileName + "\n" + 
		"HTML\t" + chmPathName + chmName + "-???.htm\n" + 
		"Images\t" + chmPathName + chmName + "-???.jpg|jpeg|png|gif\n" + 
		"Batch\t" + batFileName + "\n" + 
		"CSS\t" + cssFileName + "\n" + 
		"Log\t" + logFileName + "\n" + 
		"\n낵ł?", ANScript.YESNO );
if ( r == ANScript.YES ) {
	hhpFile.Delete();
	hhcFile.Delete();
	hhkFile.Delete();
	batFile.Delete();
	var logFile = ANScript.FileObject( logFileName );
	logFile.Delete();
	cssFile.Delete();
	deleteHTML( chmPathName + chmName, root );
	deleteImages();
}

// Show HTML Help, and finish //////////////////////////////////////////////////
r = ANScript.Confirm( "łHTMLwvĂ݂܂?", ANScript.YESNO );
if ( r == ANScript.YES ) {
	ANScript.Run( '"' + chmFileName + '"' );
}
ANScript.Quit();


// define functions ////////////////////////////////////////////////////////////
function writeHtmlFile( htmlfile, html ) {
	htmlfile.Write( 
			'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final// EN">\n' + 
			'<html>\n' + 
			html + 
			'</html>\n' );
}
function genHeader( title, filename ) {
	return new String( 
			'<head>\n' + 
			'<title>' + title + '</title>\n' + 
			'<meta name="GENERATOR" content="HTML Help Generator for ArrangeNote">\n' + 
			'<meta http-equiv="content-type" content="text/html; charset=Shift_JIS">\n' + 
			'<meta name="description" content="' + filename + '">\n' + 
			'<link rel=stylesheet type="text/css" href="wikichm_.css"></link>\n' + 
			'</head>\n' );
}
function searchTitle( title, node ) {
	if ( !node.GetChildItemCount() ) { return null; }
	var item = node.GetItem( note.CHILD );
	while( item ) {
		if ( item.Title == title ) {
			return item;
		}
		if ( item.Type == note.MEMOGROUP ) {
			var item2 = searchTitle( title, item );
			if ( item2 ) {
				return item2;
			}
		}
		item = item.GetItem( note.NEXT );
	}
	return null;
}
function wikiEscapeChars( line ) {
	var newline = line.replace( /\&/g, '&amp;' );
	newline = newline.replace( /</g, '&lt;' );
	newline = newline.replace( />/g, '&gt;' );
	newline = newline.replace( /"/g, '&quot;' );
	return newline;
}
function wikiUnescapeChars( line ) {
	var newline = line.replace( /\&quot;/g, '"' );
	newline = newline.replace( /\&gt;/g, '>' );
	newline = newline.replace( /\&lt;/g, '<' );
	newline = newline.replace( /\&amp;/g, '&' );
	return newline;
}
function wikiQuoteURL( prot, addr ) {
	if ( prot == 'mailto' ) {
		return '<a href="mailto:' + addr + '" target="_blank">' + addr + '</a>';
	} else {
		return '<a href="' + prot + ':' + addr + '" target="_blank">' + prot + ':' + addr + '</a>';
	}
}
function wikiEmbedImage( htmlTree, filename ) {
	var src, dst;
	if ( filename.charAt( 1 ) != ':' ) {
		if ( filename.charAt( 0 ) == '\\' ) {
			src = notepath.charAt( 0 ) + ':' + filename;
		} else {
			src = notepath + filename;
		}
	} else {
		src = filename;
	}
	dst = htmlTree.htmlname + '-' + 
			(++htmlTree.imageCount) + '-' + src.substr( src.lastIndexOf( '\\' ) + 1 );
	try {
		fso.CopyFile( src, dst );
	} catch( e ) {}
	var imagename = workimages.NewItem( note.MEMOGROUP, note.CHILD );
	imagename.Title = dst;
	return '<img src="' + dst.substr( dst.lastIndexOf( '\\' ) + 1 ) + '" border=0 align="middle">';
}
function wikiLink2Item( htmlTree, title ) {
	if ( /^file:\/*(localhost)?\/*(.+)$/.test( title ) ) {
		var filename = RegExp.$2;
		var url = '';
		if ( /^(.*)\|<a\shref=\"(.+?)\" target=\"_blank\">.*<\/a>$/.test( filename ) ) {
			filename = RegExp.$1;
			url = RegExp.$2;
		}
		if ( /\.(jpg|jpeg|png|gif)$/i.test( filename ) ) {
			var html = wikiEmbedImage( htmlTree, filename.replace( /\//g, '\\' ) );
		} else {
			var html = '[[' + title + ']]';	// error
		}
		if ( url.length > 0 ) {
			return '<a href="' + url + '" title="' + url + '" target="_blank">' + html + '</a>';
		} else {
			return html;
		}
	} else {
		if ( /^(.*)\|<a\shref=\"(.+?)\" target=\"_blank\">.*<\/a>$/.test( title ) ) {
			return '<a href="' + RegExp.$2 + '" title="' + RegExp.$2 + '" target="_blank">' + RegExp.$1 + '</a>';
		} else {
			var item = searchTitle( title, root );
			if ( item == null ) { return '[[' + title + ']]'; }
			return '<a href="' + chmName + '-' + item.Id + '.htm">' + title + '</a>';
		}
	}
}
function wikiProcessInline( htmlTree, line ) {
	var newline = line;
	
	// escape the link format
	newline = newline.replace( /<(file:[^>]+)>/g, '[[$1]]' );
	newline = newline.replace( /<\\\\\\([^>]+)>/g, '[[$1]]' );
	
	// escape special characters
	newline = wikiEscapeChars( newline );
	
	// make styled text
	newline = newline.replace( /'''(.+?)'''/g, '<i>$1</i>' );	// italic
	newline = newline.replace( /''(.+?)''/g, '<b>$1</b>' );		// bold
	newline = newline.replace( /==(.+?)==/g, '<s>$1</s>' );		// strikeout
	newline = newline.replace( /\|$/, '<br>' );					// break line
	
	// quote URL
	newline = newline.replace( 
			/(http|https|ftp|mailto):([^\x00-\x20()<>\]\u007f-\uffff\s]+)/g, function( $0, $1, $2 ) 
			{ return wikiQuoteURL( $1, wikiUnescapeChars( $2 ) ); } );
	
	// link to another item or escaped image file
	newline = newline.replace( /\[\[(.+?)\]\]/g, function( $0, $1 ) 
			{ return wikiLink2Item( htmlTree, wikiUnescapeChars( $1 ) ); } );
	
	// embed image file
	newline = newline.replace( 
			/file:\/*(localhost)?\/*([\w:\\\/]+?\.(jpg|jpeg|png|gif))/gi, function( $0, $1, $2 ) 
			{ return wikiEmbedImage( htmlTree, wikiUnescapeChars( $2 ).replace( /\//g, '\\' ) ); } );
	
	return newline;
}
function wikiSerializeNode( htmlTree, target ) {
	if ( target.Type == note.MEMO ) {
		htmlTree.html += target.Title + target.Body + target.Remarks + '\n';
	} else {
		htmlTree.html += target.Title + '\n';
		for( var child = target.GetItem( note.CHILD ); child; child = child.GetItem( note.NEXT ) ) {
			wikiSerializeNode( htmlTree, child );
		}
		htmlTree.html += target.Remarks + '\n';
	}
}
function wikiFlushHtmlTree( htmlTree ) {
	if ( htmlTree.root != null ) {
		wikiSerializeNode( htmlTree, htmlTree.root );
		htmlTree.root.DeleteItem();
		htmlTree.root = null;
	}
	htmlTree.parent = null;
	htmlTree.depth = 0;
}
function wikiConstructHtmlTree( htmlTree, level, openTag, closeTag ) {
	if ( htmlTree.root != null ) {
		if ( htmlTree.root.Title == openTag ) {
			while( htmlTree.depth > level ) {
				htmlTree.parent = htmlTree.parent.GetItem( note.PARENT );
				htmlTree.depth--;
			}
		} else {
			wikiFlushHtmlTree( htmlTree );
		}
	}
	if ( htmlTree.root == null ) {
		htmlTree.root = worknote.GetRootItem().NewItem( note.MEMOGROUP, note.CHILD );
	}
	while( htmlTree.depth < level ) {
		htmlTree.parent = (htmlTree.parent == null)?htmlTree.root:
				htmlTree.parent.NewItem( note.MEMOGROUP, note.CHILD );
		htmlTree.parent.Title = openTag;
		htmlTree.parent.Remarks = closeTag;
		htmlTree.depth++;
	}
}
function wikiAddElement( htmlTree, openTag, closeTag, body ) {
	var newItem = htmlTree.parent.NewItem( note.MEMO, note.CHILD );
	newItem.Title = openTag;
	newItem.Body = body;
	newItem.Remarks = closeTag;
}
function wikiAddTopic( htmlTree, level, topic ) {
	htmlTree.topicCount++;
	while( level < htmlTree.topicLevel + 1 ) {
		htmlTree.topic = htmlTree.topic.GetItem( note.PARENT );
		htmlTree.topicLevel--;
	}
	while( level > htmlTree.topicLevel + 1 ) {
		htmlTree.topic = htmlTree.topic.NewItem( note.MEMOGROUP, note.CHILD );
		htmlTree.topic.Title = '';
		htmlTree.topicLevel++;
	}
	var topichtml = '<a name="#' + htmlTree.topicCount + '">' + 
			wikiProcessInline( htmlTree, topic ) + '</a>';
	if ( level == 1 ) {
		htmlTree.html += '<h2>' + topichtml + '</h2>';
	} else {
		htmlTree.html += '<h3>' + topichtml + '</h3>';
	}
	var item = htmlTree.topic.NewItem( note.MEMOGROUP, note.CHILD );
	item.Title = topichtml.replace( /<.*?>/g, '' );
	item.Remarks = htmlTree.topicCount;
}
function wikiSerializeTopic( item ) {
	var html = '<ul class=topic>';
	for( var node = item.GetItem( note.CHILD ); node != null; node = node.GetItem( note.NEXT ) ) {
		if ( node.Title.length > 0 ) {
			html += '<li><a href="#' + node.Remarks + '">' + node.Title + '</a></li>';
		}
		if ( node.GetItem( note.CHILD ) != null ) {
			html += wikiSerializeTopic( node );
		}
	}
	html += '</ul>';
	return html;
}
function genHTML( prefix, item ) {
	var htmlTree = new Object;
	htmlTree.html = '';
	htmlTree.htmlname = prefix + '-' + item.Id;
	htmlTree.root = null;
	htmlTree.parent = null;
	htmlTree.depth = 0;
	htmlTree.imageCount = 0;
	htmlTree.topicroot = worktopics.NewItem( note.MEMOGROUP, note.CHILD );
	htmlTree.topic = htmlTree.topicroot;
	htmlTree.topicLevel = 0;
	htmlTree.topicCount = 0;
	var file = ANScript.FileObject( htmlTree.htmlname + '.htm' );
	htmlTree.html += genHeader( item.Title, file.FileName );
	var fg = item.Foreground.length?item.Foreground:note.Foreground;
	var bg = item.Background.length?item.Background:note.Background;
	htmlTree.html += '<body text="' + fg + '" bgcolor="' + bg + '">\n';
	htmlTree.html += '<p class=header>' + item.Title + '</p>\n';
	if ( item.Type == note.MEMO ) {
		var bodyLines = item.Body.split( '\n' );
		var i = 0;
		if ( bodyLines[0] == item.Title ) { i++; }
		for( ; i < bodyLines.length; i++ ) {
			if ( /^\*{4}/.test( bodyLines[i] ) ) {
				wikiFlushHtmlTree( htmlTree );
				htmlTree.html += '\n****\n';
			} else if ( /^(\*{1,2})([^\*].*)/.test( bodyLines[i] ) ) {
				wikiFlushHtmlTree( htmlTree );
				wikiAddTopic( htmlTree, RegExp.$1.length, RegExp.$2 );
			} else if ( /^----/.test( bodyLines[i] ) ) {
				wikiFlushHtmlTree( htmlTree );
				htmlTree.html += '<hr>';
			} else if ( /^(-{1,3})(.*)/.test( bodyLines[i] ) ) {
				wikiConstructHtmlTree( htmlTree, RegExp.$1.length, '<ul>', '</ul>' );
				wikiAddElement( htmlTree, '<li>', '</li>', wikiProcessInline( htmlTree, RegExp.$2 ) );
			} else if ( /^(\+{1,3})(.*)/.test( bodyLines[i] ) ) {
				wikiConstructHtmlTree( htmlTree, RegExp.$1.length, '<ol>', '</ol>' );
				wikiAddElement( htmlTree, '<li>', '</li>', wikiProcessInline( htmlTree, RegExp.$2 ) );
			} else if ( /^:([^:]+):(.*)/.test( bodyLines[i] ) ) {
				wikiConstructHtmlTree( htmlTree, 1, '<dl>', '</dl>' );
				wikiAddElement( htmlTree, '<dt>', '</dt>', wikiProcessInline( htmlTree, RegExp.$1 ) );
				wikiAddElement( htmlTree, '<dd>', '</dd>', wikiProcessInline( htmlTree, RegExp.$2 ) );
			} else if ( /^>>(.*)/.test( bodyLines[i] ) ) {
				wikiConstructHtmlTree( htmlTree, 1, '<p class=right>', '</p>' );
				wikiAddElement( htmlTree, '', '', wikiProcessInline( htmlTree, RegExp.$1 ) );
			} else if ( /^>(.*)/.test( bodyLines[i] ) ) {
				wikiConstructHtmlTree( htmlTree, 1, '<p class=center>', '</p>' );
				wikiAddElement( htmlTree, '', '', wikiProcessInline( htmlTree, RegExp.$1 ) );
			} else if ( /^\s*$/.test( bodyLines[i] ) ) {
				wikiFlushHtmlTree( htmlTree );
				wikiConstructHtmlTree( htmlTree, 1, '<p class=left>', '</p>' );
			} else if ( /^(\s+.*)$/.test( bodyLines[i] ) ) {
				wikiConstructHtmlTree( htmlTree, 1, '<pre>', '</pre>' );
				wikiAddElement( htmlTree, '', '', wikiEscapeChars( bodyLines[i] ) );
			} else if ( /^\|(.*)/.test( bodyLines[i] ) ) {
				wikiConstructHtmlTree( htmlTree, 1, '<table cellspacing=1>', '</table>' );
				var cells = RegExp.$1.split( '|' );
				var row = '';
				for( var j = 0; j < cells.length; j++ ) {
					/^\s*(\*?)(.*?)(-*)(_*)\s*$/.test( cells[j] );
					var span = '';
					if ( RegExp.$3.length ) { span += ' colspan=' + (RegExp.$3.length + 1); }
					if ( RegExp.$4.length ) { span += ' rowspan=' + (RegExp.$4.length + 1); }
					if ( RegExp.$1.length > 0 ) {
						row += '<th nowrap' + span + '>' + wikiProcessInline( htmlTree, RegExp.$2 ) + '</th>';
					} else {
						row += '<td' + span + '>' + wikiProcessInline( htmlTree, RegExp.$2 ) + '</td>';
					}
				}
				wikiAddElement( htmlTree, '<tr>', '</tr>', row );
			} else if ( /^!(.+$)/.test( bodyLines[i] ) ) {
				wikiFlushHtmlTree( htmlTree );
				var index = workindexes.NewItem( note.MEMOGROUP, note.CHILD );
				index.Title = RegExp.$1;
				index.Remarks = file.FileName;
			} else {
				if ( htmlTree.parent == null ) {
					wikiConstructHtmlTree( htmlTree, 1, '<p class=left>', '</p>' );
				}
				wikiAddElement( htmlTree, '', '', wikiProcessInline( htmlTree, bodyLines[i] ) );
			}
		}
		wikiFlushHtmlTree( htmlTree );
		if ( htmlTree.topicCount > 0 && /\n\*{4}\n/.test( htmlTree.html ) ) {
			var htmltopic = wikiSerializeTopic( htmlTree.topicroot );
			htmlTree.html = htmlTree.html.replace( /\n\*{4}\n/g, '\n' + htmltopic + '\n' );
		}
	} else {
		var subitem = item.GetItem( note.CHILD );
		htmlTree.html += '<p class=left>ł́Aȉ̍ڂɂĐ܂B</p>';
		htmlTree.html += '<ul>\n';
		while( subitem != null ) {
			var fg = '', bg = '';
			if ( subitem.Foreground != "" ) { fg = 'color: ' + subitem.Foreground; }
			if ( subitem.Background != "" ) { bg = 'background: ' + subitem.Background; }
			fg = subitem.Foreground.length?subitem.Foreground:note.Foreground;
			bg = subitem.Background.length?subitem.Background:note.Background;
			htmlTree.html += '<li><a href="' + prefix + '-' + subitem.Id + '.htm"' + 
					' style="' + fg + ';' + bg + '">';
			htmlTree.html += wikiEscapeChars( subitem.Title );
			htmlTree.html += '</a></li>\n';
			subitem = subitem.GetItem( note.NEXT );
		}
		htmlTree.html += '</ul>\n';
	}
	htmlTree.html += '</body>\n';
	writeHtmlFile( file, htmlTree.html );
	htmlTree.topicroot.DeleteItem();
	return file;
}
function genHTMLs( prefix, node ) {
	if ( node == null ) { return; }
	var item = node.GetItem( note.CHILD );
	while( item != null ) {
		var htmlfile = ANScript.FileObject( prefix + '-' + item.Id + '.htm' );
		genHTML( prefix, item );
		if ( item.Type != note.MEMO ) {
			genHTMLs( prefix, item );
		}
		item = item.GetItem( note.NEXT );
	}
}
function genContentsBody( node ) {
	if ( node == null ) { return; }
	var item = node.GetItem( note.CHILD );
	hhc += '<ul>\n';
	while( item != null ) {
		hhc += '<li><object type="text/sitemap">\n';
		hhc += '<param name="Name" value="' + item.Title + '">\n';
		hhc += '<param name="Local" value="' + chmPathName + chmName + '-' + item.Id + '.htm">\n';
		hhc += '</object>\n';
		if ( item.Type == note.MEMOGROUP ) {
			genContentsBody( item );
		}
		item = item.GetItem( note.NEXT );
	}
	hhc += '</ul>\n';
}
function genIndexBody( node ) {
	if ( node == null ) { return; }
	var item = node.GetItem( note.CHILD );
	hhc += '<ul>\n';
	while( item != null ) {
		hhk += '<li><object type="text/sitemap">\n';
		hhk += '<param name="Name" value="' + item.Title + '">\n';
		hhk += '<param name="Local" value="' + chmPathName + chmName + '-' + item.Id + '.htm">\n';
		hhk += '</object>\n';
		if ( item.Remarks.length ) {
			var remarksArray = item.Remarks.split( '|' );
			for( var i = 0; i < remarksArray.length; i++ ) {
				hhk += '<li><object type="text/sitemap">\n';
				hhk += '<param name="Name" value="' + remarksArray[i] + '">\n';
				hhk += '<param name="Name" value="' + item.Title + '">\n';
				hhk += '<param name="Local" value="' + chmPathName + chmName + '-' + item.Id + '.htm">\n';
				hhk += '</object>\n';
			}
		}
		if ( item.Type == note.MEMOGROUP ) {
			genIndexBody( item );
		}
		item = item.GetItem( note.NEXT );
	}
	hhc += '</ul>\n';
}
function genIndexBodyWiki() {
	var item = workindexes.GetItem( note.CHILD );
	hhc += '<ul>\n';
	while( item != null ) {
		hhk += '<li><object type="text/sitemap">\n';
		hhk += '<param name="Name" value="' + item.Title + '">\n';
		hhk += '<param name="Local" value="' + item.Remarks + '">\n';
		hhk += '</object>\n';
		item = item.GetItem( note.NEXT );
	}
	hhc += '</ul>\n';
}
function deleteHTML( prefix, node ) {
	if ( node == null ) { return; }
	var item = node.GetItem( note.CHILD );
	while( item != null ) {
		htmlfile = ANScript.FileObject( prefix + '-' + item.Id + '.htm' );
		htmlfile.Delete();
		if ( item.Type == note.MEMOGROUP ) {
			deleteHTML( prefix, item );
		}
		item = item.GetItem( note.NEXT );
	}
}
function deleteImages() {
	var item = workimages.GetItem( note.CHILD );
	while( item != null ) {
		try {
			fso.DeleteFile( item.Title );
		} catch( e ) {}
		item = item.GetItem( note.NEXT );
	}
}
function copyCSS( dst ) {
	var cssSourceName = ANScript.ScriptFileName;
	cssSourceName = cssSourceName.substring( 0, cssSourceName.lastIndexOf( '\\' ) + 1 );
	cssSourceName += 'wikichm.css';
	var cssFile = ANScript.FileObject( cssSourceName );
	var css = cssFile.Read();
	cssFile = ANScript.FileObject( dst );
	cssFile.Write( css );
	return cssFile;
}
